/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef APPLICATIONCONFIG_H
#define APPLICATIONCONFIG_H

#include "projectconfig.h"
#include <QSettings>

class ApplicationConfig {
    QString mcurrent;
    const QString CURRENT_PID = "current_pid";

  public:
    QString currentProject() { return mcurrent; }
    void currentProject(QString pid) { mcurrent = pid; }
    bool load() {
        QSettings settings;
        mcurrent = settings.value(CURRENT_PID).toString();
        return true;
    }
    bool save() {
        QSettings settings;
        settings.setValue(CURRENT_PID, mcurrent);
        return true;
    }
};

#endif // APPLICATIONCONFIG_H
