/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef EDITORLINK_H
#define EDITORLINK_H

#include <QString>
#include <namedfile.h>

class EditorLocation {
    NamedFile mfile;
    int manchor;
    int mposition;

  public:
    EditorLocation(NamedFile &file, int anchor, int position)
        : mfile(file), manchor(anchor), mposition(position) {}
    NamedFile &file() { return mfile; }
    int anchor() { return manchor; }
    int position() { return mposition; }
};

class EditorLink {
    EditorLocation mloc;
    QString mtext;

  public:
    EditorLink(const QString &text, NamedFile &file, int anchor, int position)
        : mloc(file, anchor, position), mtext(text) {}
    EditorLocation &location() { return mloc; }
    QString &text() { return mtext; }
};

#endif // EDITORLINK_H
