/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "mainwindow.h"
#include <QApplication>

int main(int argc, char *argv[]) {
    QApplication a(argc, argv);
    QCoreApplication::setOrganizationName("bipscript");
    QCoreApplication::setApplicationName("Bipscript IDE");

    qRegisterMetaType<Position>("Position");
    qRegisterMetaType<OscMessage>();

    try {
        MainWindow w(0, argc > 1 ? argv[1] : nullptr);
        w.showMaximized();
        return a.exec();
    } catch (const char *mesg) {
        fprintf(stderr, "%s\n", mesg);
        return 1;
    }
}
