/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MIDIEDITORWIDGET_H
#define MIDIEDITORWIDGET_H

#include "editorwidget.h"
#include <QPlainTextEdit>

struct TpmMapEntry {
    float tpm;
    union {
        uint32_t tick;
        float measure;
    };
};

class MidiEditorWidget : public QPlainTextEdit {
  public:
    MidiEditorWidget() {}
};

class MidiEditor : public Editor {
    Q_OBJECT
    MidiEditorWidget *mwidget;
    QMap<int, QString> textType;

  public:
    MidiEditor(NamedFile &file);
    ~MidiEditor() { delete mwidget; }
    QWidget *widget() override { return mwidget; }
    bool save() override { return true; }
    bool load() override;

  private:
    QString notestr(int pitch);
};

#endif // MIDIEDITORWIDGET_H
