#include "oscserver.h"

void osc_error(int, const char *, const char *) {}

int osc_handler(const char *path, const char *types, lo_arg **argv, int argc, lo_message,
                void *user_data) {
    OscMessage message;
    message.path(path);
    for (int i = 0; i < argc; i++) {
        switch (types[i]) {
        case 'i':
            message.add(*(int32_t *)argv[i]);
            break;
        case 'f':
            message.add(*(float *)argv[i]);
            break;
        case 'h':
            message.add(*(qlonglong *)argv[i]);
            break;
        case 's':
            message.add((const char *)argv[i]);
            break;
        case 'T':
            message.add(true);
            break;
        case 'F':
            message.add(false);
            break;
        case 'N':
            message.add(0); // TODO: fix this
            break;
        default:
            printf("unhandled OSC type! %c\n", types[i]);
            break;
        }
    }
    emit static_cast<OscServer *>(user_data)->message(message);
    return 0;
}

OscServer::OscServer() : QObject(nullptr) {
    st = lo_server_thread_new(NULL, osc_error);
    lo_server_thread_add_method(st, NULL, NULL, osc_handler, this);
    lo_server_thread_start(st);
}

OscServer::~OscServer() { lo_server_thread_free(st); }
