/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef PROJECTSDIALOG_H
#define PROJECTSDIALOG_H

#include "projectconfig.h"
#include "projectlist.h"

#include <QDialog>

namespace Ui {
class ProjectsDialog;
}

class ProjectsDialog : public QDialog {
    Q_OBJECT

    ProjectConfig config;
    const Project *mcurrent;

  public:
    explicit ProjectsDialog(QWidget *parent, Project *current);
    ~ProjectsDialog();

  signals:
    void projectChanged(QString);

  private slots:
    void on_cancelButton_clicked();
    void on_newButton_clicked();
    void on_openButton_clicked();
    void on_removeButton_clicked();
    void on_listWidget_itemSelectionChanged();
    void on_editButton_clicked();

  private:
    Ui::ProjectsDialog *ui;
    void syncList();
    int findProject(QString &path);
    QString commonRoot(QString &path1, QString &path2);
};

#endif // PROJECTSDIALOG_H
