#include "runeditdialog.h"
#include "ui_runeditdialog.h"

RunEditDialog::RunEditDialog(QWidget *parent, RunConfig &run)
    : QDialog(parent), mrun(run), ui(new Ui::RunEditDialog) {
    ui->setupUi(this);
    ui->nameEdit->setText(run.name());
    ui->pathText->appendPlainText(run.path().canonicalFilePath());
    ui->argsTextEdit->appendPlainText(run.args());
}

RunEditDialog::~RunEditDialog() { delete ui; }

void RunEditDialog::on_nameEdit_textEdited(const QString &name) { mrun.name(name); }

void RunEditDialog::on_argsTextEdit_textChanged() { mrun.args(ui->argsTextEdit->toPlainText()); }
