/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef SCRIPTRUN_H
#define SCRIPTRUN_H

#include <QFileInfo>
#include <QThread>

#include <boost/lockfree/queue.hpp>

class ScriptRun : public QThread {
    Q_OBJECT

    static QString executable;
    QFileInfo script;
    QString marguments;
    int mport;
    boost::lockfree::queue<char *> inputq;
    void run() override;

  public:
    ScriptRun(const QString &path, const QString &args, int port)
        : script(path), marguments(args), mport(port), inputq(8192) {}
    static void setExecutable(QString &exec);
    static bool possible();
  public slots:
    void writeStdin(QString);
  signals:
    void started(int pid);
    void readStdout(const char *);
    void readStderr(QString);
    void error(QString);
    void exited(int status);
};

#endif // SCRIPTRUN_H
