/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef SEARCHTERM_H
#define SEARCHTERM_H

#include <QString>

class SearchTerm {
    const QString mterm;
    const bool mcaseSensitive;

  public:
    SearchTerm(QString term, bool caseSensitive) : mterm(term), mcaseSensitive(caseSensitive) {}
    QString string() const { return mterm; }
    bool caseSensitive() const { return mcaseSensitive; }
};

#endif // SEARCHTERM_H
