/*
 * This file is part of Bipscript-IDE.
 *
 * Bipscript-IDE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript-IDE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript-IDE.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef SYNHIGHLIGHTER_H
#define SYNHIGHLIGHTER_H

#include <QSet>
#include <QSyntaxHighlighter>
#include <QTextCharFormat>

struct HighlighterRule {
    QRegExp pattern;
    QTextCharFormat format;
};

class QTextDocument;

class SynHighlighter : public QSyntaxHighlighter {
    Q_OBJECT

  public:
    SynHighlighter(QTextDocument *parent);

  protected:
    void highlightBlock(const QString &text) override;

  private:
    QList<HighlighterRule> rules;

    const QString startString;
    const QString endString;
    QTextCharFormat stringFormat;

    const QString startComment;
    const QString endComment;
    QTextCharFormat commentFormat;

    void addRule(const QRegExp &regex, const QTextCharFormat &format);
};

#endif // SYNHIGHLIGHTER_H
